// Code by P. Laurent -- Nov 2016

import java.util.List;

int u=10; //unit of the lattice. A smaller u means a finer grid 
int speed=100; //speed of the animation
int w=1280; //width of the screen
int h=800; //height of the screen

int curX;
int curY;
int newX;
int newY;
ArrayList<Integer> LERWX= new ArrayList();
ArrayList<Integer> LERWY= new ArrayList();
ArrayList<Integer> visitedX= new ArrayList();
ArrayList<Integer> visitedY= new ArrayList();
int startX;
int startY;
Boolean ended=false;
Boolean bool=false;
int nbPoints=ceil((h-u)/u)*ceil((w-u)/u);

//all points are of the form u*(n,m) where u is the unit
void setup() {
  fullScreen();
  background(0);
  curX=ceil(random(1, (w-2*u)/u))*u;
  curY=ceil(random(1, (h-2*u)/u))*u;
  startX=curX;
  startY=curY;
  LERWX.add(curX);
  LERWY.add(curY);
  visitedX.add(ceil(random(1, (w-2*u)/u))*u);
  visitedY.add(ceil(random(1, (h-2*u)/u))*u);
  fill(255, 0, 0);
  ellipse(visitedX.get(0), visitedY.get(0), 5, 5);
  ellipse(curX, curY, 5, 5);
}

void draw() {
  for (int j=0; j<speed; j++) {
    addPoint();
  }
}

int isin(int x, int y) { //checks if the RW is doing a loop, return the index of the origin of the loop
  for (int k=0; k<LERWX.size(); k++) {
    if (LERWX.get(k) == x && LERWY.get(k) == y) {
      return k;
    }
  }
  return -1;
}

void eraseLoop(int index) { //if the RW closes a loop, it is deleted
  if (index!=-1) {
    stroke(0);
    for (int l=LERWX.size()-1; l>index; l--) {
      line(LERWX.get(l), LERWY.get(l), LERWX.get(l-1), LERWY.get(l-1));
      LERWX.remove(l);
      LERWY.remove(l);
    }
  }
}

Boolean visited(int x, int y) { //checks if the LERW hits a point already in the tree
  for (int k=0; k<visitedX.size(); k++) {
    if (x == visitedX.get(k) && y == visitedY.get(k)) return true;
  }
  return false;
}

void validPath() { //if it hits a point of the tree, add the whole path to the tree
  for (int k=0; k<LERWX.size()-1; k++) {
    stroke(255);
    line(LERWX.get(k), LERWY.get(k), LERWX.get(k+1), LERWY.get(k+1));
    visitedX.add(LERWX.get(k));
    visitedY.add(LERWY.get(k));
  }
  LERWX.clear();
  LERWY.clear();
}

void addPoint() {
  bool=false;
  if (ended==false) {
    if (visited(curX, curY)) {
      validPath();
      while (visited(startX, startY)==true && ended==false) { //chooses a new vertex not in the current tree
        startX=ceil(random(0, (w-u)/u))*u;
        startY=ceil(random(0, (h-u)/u))*u;
        if (visitedX.size()==nbPoints) {
          ended=true;
        }
      }
      LERWX.add(startX);
      LERWY.add(startY);
      curX=startX;
      curY=startY;
    } else {
      while (newX<u || newX>w-u || newY<u || newY>h-u || bool==false) {
        bool=true;
        newX=curX;
        newY=curY;
        if (random(1)<0.5) {
          if (random(1)<0.5) newX=curX+u;
          else newX=curX-u;
        } else {
          if (random(1)<0.5) newY=curY+u;
          else newY=curY-u;
        }
      }
      LERWX.add(newX);
      LERWY.add(newY);
      stroke(0, 255, 0);
      line(curX, curY, newX, newY);
      curX=newX;
      curY=newY;
      eraseLoop(isin(curX, curY));
    }
  }
}